/*******************************************************************************
 * FoxSpecialMove_Sprint generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSpecialMove_Sprint extends FoxSpecialMove
    native(SpecialMoves);

var() float TurnScale;
var() float StrafeScale;

function bool CanChainMove(FoxTypes.ESpecialMove NextMove)
{
    ServerChainedMove = NextMove;
    return true;
    //return ReturnValue;    
}

protected function bool InternalCanDoSpecialMove()
{
    // End:0x6E
    if((PawnOwner.Physics != 1) || PawnOwner.Stamina < PawnOwner.MinimumStaminaToSprint)
    {
        return false;
    }
    // End:0xBA
    if(PawnOwner.IsDoingSpecialMove(17) || PawnOwner.IsDoingSpecialMove(21))
    {
        return false;
    }
    // End:0x11B
    if((PawnOwner.CarriedObject != none) && !PawnOwner.CarriedObject.bCanSprint)
    {
        return false;
    }
    return true;
    //return ReturnValue;    
}

// Export UFoxSpecialMove_Sprint::execPreProcessInput(FFrame&, void* const)
native simulated function bool PreProcessInput(FoxPlayerInput Input);

simulated function StartSpecialMove()
{
    super.StartSpecialMove();
    // End:0x133
    if(PawnOwner.Role == ROLE_Authority)
    {
        FoxPC(PawnOwner.Controller).ClientNotifySprintDepletedStop();
        // End:0x133
        if((FoxPRI(PawnOwner.PlayerReplicationInfo) != none) && FoxPRI(PawnOwner.PlayerReplicationInfo).WeaponUsageStats != none)
        {
            FoxPRI(PawnOwner.PlayerReplicationInfo).WeaponUsageStats.IncrementSprints();
        }
    }
    // End:0x186
    if(PawnOwner.IsLocallyControlled())
    {
        PawnOwner.SetState('Movement', 'Sprint');
    }
    //return;    
}

simulated function CleanUpSpecialMove()
{
    // End:0xA9
    if((PawnOwner.Role == ROLE_Authority) && PawnOwner.Stamina < PawnOwner.SprintingStaminaUsagePerSecond)
    {
        FoxPC(PawnOwner.Controller).ClientNotifySprintDepletedStart();
    }
    // End:0xFC
    if(PawnOwner.IsLocallyControlled())
    {
        PawnOwner.SetState('Movement', 'Run');
    }
    super.CleanUpSpecialMove();
    //return;    
}

defaultproperties
{
    TurnScale=1.0
    StrafeScale=0.330
    bCanFireWeapon=false
    bCanChangeCrouchState=true
    bShouldAbortTightAim=true
    bIsAbortedByTightAim=true
    bDisableLedgeDetection=false
    bLocallySimulated=true
}